package dpf.osgi.ext;

import java.util.LinkedList;

import base dpf.osgi.base.Person;

public team class University {

	precedence Student, Professor;

	public void register(Person as Student student, int matrikel) {
		student.matrikel = matrikel;
	}

	public void attendLecture(Person as Student student, String lecture) {
		student.attendedLectures.add(lecture);
		System.out.println(student.getName() + " now attends the lecture on " + lecture + ".");
	}
	
	public void printLecturesOfStudent(Person as Student student) {
		student.printAttendedLectures();
	}
	
	public class Student playedBy Person
		base when (University.this.hasRole(base, Student.class)) {

		String getName() -> String getName();
		studentIdentify <- before identify;

		protected int matrikel;
		protected LinkedList<String> attendedLectures = new LinkedList<String>();

		public void studentIdentify() {
			System.out.println("Matrikel: " + matrikel);
		}
		
		public void printAttendedLectures() {
			System.out.println(getName() + " attends the following lectures:");
			for (String lecture : attendedLectures) {
				System.out.println("  " + lecture);
			}
		}
	}

	public void hireProfessor(Person as Professor prof, String group) when (!University.this.hasRole(prof, Student.class)) {
		prof.group = group;
		System.out.println(prof.getName() + " is now professor at the " + group + " group.");
	}
	
	public void offerLecture(Person as Professor prof, String lecture) when (University.this.hasRole(prof, Professor.class)) {
		prof.offeredLectures.add(lecture);
		System.out.println(prof.getName() + " now offers a lecture on " + lecture + ".");
	}

	public class Professor playedBy Person
		base when (University.this.hasRole(base, Professor.class)) {

		String getName() -> String getName();
		professorIdentify <- replace identify;

		protected String group;
		protected LinkedList<String> offeredLectures = new LinkedList<String>();

		@SuppressWarnings("basecall")
		callin void professorIdentify() {
			System.out.println(getName() + " is professor of the " + group + " group.");
		}
	}
}
