package dpf.osgi;

import org.eclipse.equinox.app.IApplication;
import org.eclipse.equinox.app.IApplicationContext;

import dpf.osgi.base.Person;
import dpf.osgi.ext.University;

public class Apparat implements IApplication {

	@Override
	public Object start(IApplicationContext context) throws Exception {
		Person hans = new Person("Hans");
	    Person karl = new Person("Karl");
	    Person uwe = new Person("Uwe");
	    System.out.println("--No context--");
	    hans.identify();
	    karl.identify();
	    uwe.identify();
	    
	    University u = new University();
	    u.activate();
	    System.out.println("--Uni active-----");
	    u.register(hans, 123);
	    u.register(karl, 345);
	    u.hireProfessor(uwe, "Software Technology");
	    hans.identify();
	    karl.identify();
	    uwe.identify();
	    
	    u.offerLecture(uwe, "DPF");
	    u.attendLecture(hans, "DPF");
	    u.attendLecture(karl, "DPF");
	    u.printLecturesOfStudent(karl);
	    
	    u.deactivate();
	    System.out.println("--Uni inactive---");
	    hans.identify();
	    karl.identify();
	    uwe.identify();
	    return null;
	}

	@Override
	public void stop() {
	}

}
